/*****************************************************
Project : Ambilight   
Version : 1.2
Date    : 10.08.2009
Author  : StalkerSVR
Comments:
 - 8
  - 14.7456
   USART  

Chip type           : ATmega8
Program type        : Application
Clock frequency     : 14,745600 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <stdio.h>
#include <delay.h>

#define R1 PORTC.3
#define G1 PORTC.4
#define B1 PORTC.5
#define R2 PORTC.0
#define G2 PORTC.1
#define B2 PORTC.2
#define R3 PORTB.2
#define G3 PORTB.3
#define B3 PORTB.4
#define R4 PORTD.7
#define G4 PORTB.0
#define B4 PORTB.1
#define MYCHANNELS 12 // ,    


char R[5];
char G[5];
char B[5];
char E[5]; //Enable

char rx_buffer[30];
char tx_buffer[50];
char rx_index=0;
char tx_index=0;
char tx_index_tx=0;
char start_channel;
char current_channel;
char num_channels;
char read_byte;
char need_rx=0;
char counter=0;
char packet_len=0;
char i;

void main(void)
{

PORTB=0x00;
DDRB=0x00;
PORTC=0x00;
DDRC=0x00;
PORTD=0x00;
DDRD=0x00;

DDRC.3=1;//R1
DDRC.4=1;//G1
DDRC.5=1;//B1
DDRC.0=1;//R2
DDRC.1=1;//G2
DDRC.2=1;//B2
DDRB.2=1;//R3
DDRB.3=1;//G3
DDRB.4=1;//B3
DDRD.7=1;//R4
DDRB.0=1;//G4
DDRB.1=1;//B4

DDRD.0=0; //RXD
DDRD.1=1; //TXD

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 38400
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x17;
//UBRRL=0x0C;


  R[1]=0;
  G[1]=0;
  B[1]=0;
  E[1]=0;
  R[2]=0;
  G[2]=0;
  B[2]=0;
  E[2]=0;
  R[3]=0;
  G[3]=0;
  B[3]=0;
  E[3]=0;
  R[4]=0;
  G[4]=0;
  B[4]=0;
  E[4]=0;
  R1=0;
  R2=0;
  R3=0;
  R4=0;
  G1=0;
  G2=0;
  G3=0;
  G4=0;
  B1=0;
  B2=0;
  B3=0;
  B4=0;




// Global enable interrupts
  #asm("sei")

rx_index=0;
need_rx=0;
packet_len=0;

for (i=0;i<30;i++) rx_buffer[i]=0;
for (i=0;i<50;i++) tx_buffer[i]=0;


  while (1)
  {
    counter++;
    if(counter==0)
    {
        if(R[1]) R1=1; else R1=0;
        if(R[2]) R2=1; else R2=0;
        if(R[3]) R3=1; else R3=0;
        if(R[4]) R4=1; else R4=0;
        if(G[1]) G1=1; else G1=0;
        if(G[2]) G2=1; else G2=0;
        if(G[3]) G3=1; else G3=0;
        if(G[4]) G4=1; else G4=0;
        if(B[1]) B1=1; else B1=0;
        if(B[2]) B2=1; else B2=0;
        if(B[3]) B3=1; else B3=0;
        if(B[4]) B4=1; else B4=0;

    }

    if(counter>R[1])R1=0; if(counter>G[1])G1=0; if(counter>B[1])B1=0;
    if(counter>R[2])R2=0; if(counter>G[2])G2=0; if(counter>B[2])B2=0;
    if(counter>R[3])R3=0; if(counter>G[3])G3=0; if(counter>B[3])B3=0;
    if(counter>R[4])R4=0; if(counter>G[4])G4=0; if(counter>B[4])B4=0;

    if(UCSRA.7==1)
    {
      read_byte=UDR;

      switch (rx_index)
      {
        case 0:
                if (read_byte==0xFF) //////////////////////////////
                {
                        need_rx=1; // 
                        tx_buffer[tx_index]=0xFF; ///////////////
                        tx_index++;
                        rx_index++;
                };
                break;

        case 1:
//                read_byte=0; ////////////////////////////////
                if (read_byte<MYCHANNELS)
                { //     
                        tx_buffer[tx_index]=0;
                }
                else
                {       //    
                         tx_buffer[tx_index]=read_byte - MYCHANNELS;
                }
                tx_index++;
                rx_index++;
                current_channel=read_byte;
                start_channel=read_byte;
                break;

        case 2: // ignore,  256 , HIGH BYTE 
                tx_buffer[tx_index]=0; // 0  
                tx_index++;
                rx_index++;
                break;

        case 3:
                if(!read_byte)
                {//  0 .         
                         tx_buffer[tx_index]=0; // 0  
                }
                else
                {// 
                         if(read_byte+start_channel<=MYCHANNELS)
                         {//    
                                   tx_buffer[tx_index]=0;
                         }
                         else
                         {//   - 
                                   if (start_channel<MYCHANNELS)
                                   {//   .      
                                          tx_buffer[tx_index]=read_byte - MYCHANNELS  + start_channel;
                                   }
                                   else
                                   {//     
                                          tx_buffer[tx_index]=read_byte;
                                   }
                         }
                         num_channels=read_byte;
                }
                packet_len=4+read_byte; //     +  
                tx_index++;
                rx_index++;
                break;

        default:
                if (need_rx)
                {
                        if (current_channel<MYCHANNELS)
                        {//   
                               rx_buffer[current_channel]=read_byte;
                        }
                        else
                        {//   ,   
                               tx_buffer[tx_index]=read_byte;
                               tx_index++;
                        }
                        current_channel++;
                        rx_index++;
                }
                break;

      }

      if ((rx_index>=packet_len)&&(packet_len)) //     
      {
          rx_index=0;
          need_rx=0;
          packet_len=0;
          R[1]=rx_buffer[0];
          G[1]=rx_buffer[1];
          B[1]=rx_buffer[2];
          R[2]=rx_buffer[3];
          G[2]=rx_buffer[4];
          B[2]=rx_buffer[5];
          R[3]=rx_buffer[6];
          G[3]=rx_buffer[7];
          B[3]=rx_buffer[8];
          R[4]=rx_buffer[9];
          G[4]=rx_buffer[10];
          B[4]=rx_buffer[11];
      }
    }

    if (tx_index==50) tx_index=0;
    if (tx_index_tx==50) tx_index_tx=0;

//    if ((tx_index_tx!=tx_index)&&(!(UCSRA.5)))
    if (tx_index_tx!=tx_index)
    {//      
//        UDR = tx_buffer[tx_index_tx];
        putchar(tx_buffer[tx_index_tx]);
        tx_index_tx++;
    }
  }
}
