
;CodeVisionAVR C Compiler V1.25.9 Professional
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 14,745600 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : int
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Atmolight.vec"
	.INCLUDE "Atmolight.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 Project : Ambilight   
;       3 Version : 1.2
;       4 Date    : 10.08.2009
;       5 Author  : StalkerSVR
;       6 Comments:
;       7  - 8
;       8   - 14.7456
;       9    USART  
;      10 
;      11 Chip type           : ATmega8
;      12 Program type        : Application
;      13 Clock frequency     : 14,745600 MHz
;      14 Memory model        : Small
;      15 External SRAM size  : 0
;      16 Data Stack size     : 256
;      17 *****************************************************/
;      18 
;      19 #include <mega8.h>
;      20 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      21 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      22 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;      23 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;      24 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      25 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      26 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;      27 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      28 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      29 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      30 	#endif
	#endif
;      31 #include <stdio.h>
;      32 #include <delay.h>
;      33 
;      34 #define R1 PORTC.3
;      35 #define G1 PORTC.4
;      36 #define B1 PORTC.5
;      37 #define R2 PORTC.0
;      38 #define G2 PORTC.1
;      39 #define B2 PORTC.2
;      40 #define R3 PORTB.2
;      41 #define G3 PORTB.3
;      42 #define B3 PORTB.4
;      43 #define R4 PORTD.7
;      44 #define G4 PORTB.0
;      45 #define B4 PORTB.1
;      46 #define MYCHANNELS 12 // ,    
;      47 
;      48 
;      49 char R[5];
_R:
	.BYTE 0x5
;      50 char G[5];
_G:
	.BYTE 0x5
;      51 char B[5];
_B:
	.BYTE 0x5
;      52 char E[5]; //Enable
_E:
	.BYTE 0x5
;      53 
;      54 char rx_buffer[30];
_rx_buffer:
	.BYTE 0x1E
;      55 char tx_buffer[50];
_tx_buffer:
	.BYTE 0x32
;      56 char rx_index=0;
;      57 char tx_index=0;
;      58 char tx_index_tx=0;
;      59 char start_channel;
;      60 char current_channel;
;      61 char num_channels;
;      62 char read_byte;
;      63 char need_rx=0;
;      64 char counter=0;
;      65 char packet_len=0;
;      66 char i;
_i:
	.BYTE 0x1
;      67 
;      68 void main(void)
;      69 {

	.CSEG
_main:
;      70 
;      71 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;      72 DDRB=0x00;
	OUT  0x17,R30
;      73 PORTC=0x00;
	OUT  0x15,R30
;      74 DDRC=0x00;
	OUT  0x14,R30
;      75 PORTD=0x00;
	OUT  0x12,R30
;      76 DDRD=0x00;
	OUT  0x11,R30
;      77 
;      78 DDRC.3=1;//R1
	SBI  0x14,3
;      79 DDRC.4=1;//G1
	SBI  0x14,4
;      80 DDRC.5=1;//B1
	SBI  0x14,5
;      81 DDRC.0=1;//R2
	SBI  0x14,0
;      82 DDRC.1=1;//G2
	SBI  0x14,1
;      83 DDRC.2=1;//B2
	SBI  0x14,2
;      84 DDRB.2=1;//R3
	SBI  0x17,2
;      85 DDRB.3=1;//G3
	SBI  0x17,3
;      86 DDRB.4=1;//B3
	SBI  0x17,4
;      87 DDRD.7=1;//R4
	SBI  0x11,7
;      88 DDRB.0=1;//G4
	SBI  0x17,0
;      89 DDRB.1=1;//B4
	SBI  0x17,1
;      90 
;      91 DDRD.0=0; //RXD
	CBI  0x11,0
;      92 DDRD.1=1; //TXD
	SBI  0x11,1
;      93 
;      94 // Timer(s)/Counter(s) Interrupt(s) initialization
;      95 TIMSK=0x00;
	OUT  0x39,R30
;      96 
;      97 // USART initialization
;      98 // Communication Parameters: 8 Data, 1 Stop, No Parity
;      99 // USART Receiver: On
;     100 // USART Transmitter: On
;     101 // USART Mode: Asynchronous
;     102 // USART Baud Rate: 38400
;     103 UCSRA=0x00;
	OUT  0xB,R30
;     104 UCSRB=0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
;     105 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     106 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     107 UBRRL=0x17;
	LDI  R30,LOW(23)
	OUT  0x9,R30
;     108 //UBRRL=0x0C;
;     109 
;     110 
;     111   R[1]=0;
	LDI  R30,LOW(0)
	__PUTB1MN _R,1
;     112   G[1]=0;
	__PUTB1MN _G,1
;     113   B[1]=0;
	__PUTB1MN _B,1
;     114   E[1]=0;
	__PUTB1MN _E,1
;     115   R[2]=0;
	__PUTB1MN _R,2
;     116   G[2]=0;
	__PUTB1MN _G,2
;     117   B[2]=0;
	__PUTB1MN _B,2
;     118   E[2]=0;
	__PUTB1MN _E,2
;     119   R[3]=0;
	__PUTB1MN _R,3
;     120   G[3]=0;
	__PUTB1MN _G,3
;     121   B[3]=0;
	__PUTB1MN _B,3
;     122   E[3]=0;
	__PUTB1MN _E,3
;     123   R[4]=0;
	__PUTB1MN _R,4
;     124   G[4]=0;
	__PUTB1MN _G,4
;     125   B[4]=0;
	__PUTB1MN _B,4
;     126   E[4]=0;
	__PUTB1MN _E,4
;     127   R1=0;
	CBI  0x15,3
;     128   R2=0;
	CBI  0x15,0
;     129   R3=0;
	CBI  0x18,2
;     130   R4=0;
	CBI  0x12,7
;     131   G1=0;
	CBI  0x15,4
;     132   G2=0;
	CBI  0x15,1
;     133   G3=0;
	CBI  0x18,3
;     134   G4=0;
	CBI  0x18,0
;     135   B1=0;
	CBI  0x15,5
;     136   B2=0;
	CBI  0x15,2
;     137   B3=0;
	CBI  0x18,4
;     138   B4=0;
	CBI  0x18,1
;     139 
;     140 
;     141 
;     142 
;     143 // Global enable interrupts
;     144   #asm("sei")
	sei
;     145 
;     146 rx_index=0;
	CLR  R5
;     147 need_rx=0;
	CLR  R10
;     148 packet_len=0;
	CLR  R12
;     149 
;     150 for (i=0;i<30;i++) rx_buffer[i]=0;
	LDI  R30,LOW(0)
	STS  _i,R30
_0x38:
	LDS  R26,_i
	CPI  R26,LOW(0x1E)
	BRSH _0x39
	LDS  R30,_i
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LDI  R26,LOW(0)
	STD  Z+0,R26
;     151 for (i=0;i<50;i++) tx_buffer[i]=0;
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0x38
_0x39:
	LDI  R30,LOW(0)
	STS  _i,R30
_0x3B:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x3C
	LDS  R30,_i
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	LDI  R26,LOW(0)
	STD  Z+0,R26
;     152 
;     153 
;     154   while (1)
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0x3B
_0x3C:
_0x3D:
;     155   {
;     156     counter++;
	INC  R13
;     157     if(counter==0)
	TST  R13
	BREQ PC+2
	RJMP _0x40
;     158     {
;     159         if(R[1]) R1=1; else R1=0;
	__GETB1MN _R,1
	CPI  R30,0
	BREQ _0x41
	SBI  0x15,3
	RJMP _0x44
_0x41:
	CBI  0x15,3
;     160         if(R[2]) R2=1; else R2=0;
_0x44:
	__GETB1MN _R,2
	CPI  R30,0
	BREQ _0x47
	SBI  0x15,0
	RJMP _0x4A
_0x47:
	CBI  0x15,0
;     161         if(R[3]) R3=1; else R3=0;
_0x4A:
	__GETB1MN _R,3
	CPI  R30,0
	BREQ _0x4D
	SBI  0x18,2
	RJMP _0x50
_0x4D:
	CBI  0x18,2
;     162         if(R[4]) R4=1; else R4=0;
_0x50:
	__GETB1MN _R,4
	CPI  R30,0
	BREQ _0x53
	SBI  0x12,7
	RJMP _0x56
_0x53:
	CBI  0x12,7
;     163         if(G[1]) G1=1; else G1=0;
_0x56:
	__GETB1MN _G,1
	CPI  R30,0
	BREQ _0x59
	SBI  0x15,4
	RJMP _0x5C
_0x59:
	CBI  0x15,4
;     164         if(G[2]) G2=1; else G2=0;
_0x5C:
	__GETB1MN _G,2
	CPI  R30,0
	BREQ _0x5F
	SBI  0x15,1
	RJMP _0x62
_0x5F:
	CBI  0x15,1
;     165         if(G[3]) G3=1; else G3=0;
_0x62:
	__GETB1MN _G,3
	CPI  R30,0
	BREQ _0x65
	SBI  0x18,3
	RJMP _0x68
_0x65:
	CBI  0x18,3
;     166         if(G[4]) G4=1; else G4=0;
_0x68:
	__GETB1MN _G,4
	CPI  R30,0
	BREQ _0x6B
	SBI  0x18,0
	RJMP _0x6E
_0x6B:
	CBI  0x18,0
;     167         if(B[1]) B1=1; else B1=0;
_0x6E:
	__GETB1MN _B,1
	CPI  R30,0
	BREQ _0x71
	SBI  0x15,5
	RJMP _0x74
_0x71:
	CBI  0x15,5
;     168         if(B[2]) B2=1; else B2=0;
_0x74:
	__GETB1MN _B,2
	CPI  R30,0
	BREQ _0x77
	SBI  0x15,2
	RJMP _0x7A
_0x77:
	CBI  0x15,2
;     169         if(B[3]) B3=1; else B3=0;
_0x7A:
	__GETB1MN _B,3
	CPI  R30,0
	BREQ _0x7D
	SBI  0x18,4
	RJMP _0x80
_0x7D:
	CBI  0x18,4
;     170         if(B[4]) B4=1; else B4=0;
_0x80:
	__GETB1MN _B,4
	CPI  R30,0
	BREQ _0x83
	SBI  0x18,1
	RJMP _0x86
_0x83:
	CBI  0x18,1
;     171 
;     172     }
_0x86:
;     173 
;     174     if(counter>R[1])R1=0; if(counter>G[1])G1=0; if(counter>B[1])B1=0;
_0x40:
	__GETB1MN _R,1
	CP   R30,R13
	BRSH _0x89
	CBI  0x15,3
_0x89:
	__GETB1MN _G,1
	CP   R30,R13
	BRSH _0x8C
	CBI  0x15,4
_0x8C:
	__GETB1MN _B,1
	CP   R30,R13
	BRSH _0x8F
	CBI  0x15,5
;     175     if(counter>R[2])R2=0; if(counter>G[2])G2=0; if(counter>B[2])B2=0;
_0x8F:
	__GETB1MN _R,2
	CP   R30,R13
	BRSH _0x92
	CBI  0x15,0
_0x92:
	__GETB1MN _G,2
	CP   R30,R13
	BRSH _0x95
	CBI  0x15,1
_0x95:
	__GETB1MN _B,2
	CP   R30,R13
	BRSH _0x98
	CBI  0x15,2
;     176     if(counter>R[3])R3=0; if(counter>G[3])G3=0; if(counter>B[3])B3=0;
_0x98:
	__GETB1MN _R,3
	CP   R30,R13
	BRSH _0x9B
	CBI  0x18,2
_0x9B:
	__GETB1MN _G,3
	CP   R30,R13
	BRSH _0x9E
	CBI  0x18,3
_0x9E:
	__GETB1MN _B,3
	CP   R30,R13
	BRSH _0xA1
	CBI  0x18,4
;     177     if(counter>R[4])R4=0; if(counter>G[4])G4=0; if(counter>B[4])B4=0;
_0xA1:
	__GETB1MN _R,4
	CP   R30,R13
	BRSH _0xA4
	CBI  0x12,7
_0xA4:
	__GETB1MN _G,4
	CP   R30,R13
	BRSH _0xA7
	CBI  0x18,0
_0xA7:
	__GETB1MN _B,4
	CP   R30,R13
	BRSH _0xAA
	CBI  0x18,1
;     178 
;     179     if(UCSRA.7==1)
_0xAA:
	SBIS 0xB,7
	RJMP _0xAD
;     180     {
;     181       read_byte=UDR;
	IN   R11,12
;     182 
;     183       switch (rx_index)
	MOV  R30,R5
;     184       {
;     185         case 0:
	CPI  R30,0
	BRNE _0xB1
;     186                 if (read_byte==0xFF) //////////////////////////////
	LDI  R30,LOW(255)
	CP   R30,R11
	BRNE _0xB2
;     187                 {
;     188                         need_rx=1; // 
	LDI  R30,LOW(1)
	MOV  R10,R30
;     189                         tx_buffer[tx_index]=0xFF; ///////////////
	MOV  R30,R4
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	LDI  R26,LOW(255)
	STD  Z+0,R26
;     190                         tx_index++;
	INC  R4
;     191                         rx_index++;
	INC  R5
;     192                 };
_0xB2:
;     193                 break;
	RJMP _0xB0
;     194 
;     195         case 1:
_0xB1:
	CPI  R30,LOW(0x1)
	BRNE _0xB3
;     196 //                read_byte=0; ////////////////////////////////
;     197                 if (read_byte<MYCHANNELS)
	LDI  R30,LOW(12)
	CP   R11,R30
	BRSH _0xB4
;     198                 { //     
;     199                         tx_buffer[tx_index]=0;
	MOV  R30,R4
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	LDI  R26,LOW(0)
	STD  Z+0,R26
;     200                 }
;     201                 else
	RJMP _0xB5
_0xB4:
;     202                 {       //    
;     203                          tx_buffer[tx_index]=read_byte - MYCHANNELS;
	MOV  R26,R4
	LDI  R27,0
	SUBI R26,LOW(-_tx_buffer)
	SBCI R27,HIGH(-_tx_buffer)
	MOV  R30,R11
	SUBI R30,LOW(12)
	ST   X,R30
;     204                 }
_0xB5:
;     205                 tx_index++;
	INC  R4
;     206                 rx_index++;
	INC  R5
;     207                 current_channel=read_byte;
	MOV  R9,R11
;     208                 start_channel=read_byte;
	MOV  R6,R11
;     209                 break;
	RJMP _0xB0
;     210 
;     211         case 2: // ignore,  256 , HIGH BYTE 
_0xB3:
	CPI  R30,LOW(0x2)
	BRNE _0xB6
;     212                 tx_buffer[tx_index]=0; // 0  
	MOV  R30,R4
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	LDI  R26,LOW(0)
	STD  Z+0,R26
;     213                 tx_index++;
	INC  R4
;     214                 rx_index++;
	RJMP _0x168
;     215                 break;
;     216 
;     217         case 3:
_0xB6:
	CPI  R30,LOW(0x3)
	BRNE _0xBE
;     218                 if(!read_byte)
	TST  R11
	BRNE _0xB8
;     219                 {//  0 .         
;     220                          tx_buffer[tx_index]=0; // 0  
	MOV  R30,R4
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	LDI  R26,LOW(0)
	STD  Z+0,R26
;     221                 }
;     222                 else
	RJMP _0xB9
_0xB8:
;     223                 {// 
;     224                          if(read_byte+start_channel<=MYCHANNELS)
	MOV  R26,R6
	ADD  R26,R11
	CPI  R26,LOW(0xD)
	BRSH _0xBA
;     225                          {//    
;     226                                    tx_buffer[tx_index]=0;
	MOV  R30,R4
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	LDI  R26,LOW(0)
	STD  Z+0,R26
;     227                          }
;     228                          else
	RJMP _0xBB
_0xBA:
;     229                          {//   - 
;     230                                    if (start_channel<MYCHANNELS)
	LDI  R30,LOW(12)
	CP   R6,R30
	BRSH _0xBC
;     231                                    {//   .      
;     232                                           tx_buffer[tx_index]=read_byte - MYCHANNELS  + start_channel;
	MOV  R26,R4
	LDI  R27,0
	SUBI R26,LOW(-_tx_buffer)
	SBCI R27,HIGH(-_tx_buffer)
	MOV  R30,R11
	SUBI R30,LOW(12)
	ADD  R30,R6
	ST   X,R30
;     233                                    }
;     234                                    else
	RJMP _0xBD
_0xBC:
;     235                                    {//     
;     236                                           tx_buffer[tx_index]=read_byte;
	MOV  R30,R4
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	ST   Z,R11
;     237                                    }
_0xBD:
;     238                          }
_0xBB:
;     239                          num_channels=read_byte;
	MOV  R8,R11
;     240                 }
_0xB9:
;     241                 packet_len=4+read_byte; //     +  
	MOV  R30,R11
	SUBI R30,-LOW(4)
	MOV  R12,R30
;     242                 tx_index++;
	INC  R4
;     243                 rx_index++;
	RJMP _0x168
;     244                 break;
;     245 
;     246         default:
_0xBE:
;     247                 if (need_rx)
	TST  R10
	BREQ _0xBF
;     248                 {
;     249                         if (current_channel<MYCHANNELS)
	LDI  R30,LOW(12)
	CP   R9,R30
	BRSH _0xC0
;     250                         {//   
;     251                                rx_buffer[current_channel]=read_byte;
	MOV  R30,R9
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	ST   Z,R11
;     252                         }
;     253                         else
	RJMP _0xC1
_0xC0:
;     254                         {//   ,   
;     255                                tx_buffer[tx_index]=read_byte;
	MOV  R30,R4
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	ST   Z,R11
;     256                                tx_index++;
	INC  R4
;     257                         }
_0xC1:
;     258                         current_channel++;
	INC  R9
;     259                         rx_index++;
_0x168:
	INC  R5
;     260                 }
;     261                 break;
_0xBF:
;     262 
;     263       }
_0xB0:
;     264 
;     265       if ((rx_index>=packet_len)&&(packet_len)) //     
	CP   R5,R12
	BRLO _0xC3
	TST  R12
	BRNE _0xC4
_0xC3:
	RJMP _0xC2
_0xC4:
;     266       {
;     267           rx_index=0;
	CLR  R5
;     268           need_rx=0;
	CLR  R10
;     269           packet_len=0;
	CLR  R12
;     270           R[1]=rx_buffer[0];
	LDS  R30,_rx_buffer
	__PUTB1MN _R,1
;     271           G[1]=rx_buffer[1];
	__GETB1MN _rx_buffer,1
	__PUTB1MN _G,1
;     272           B[1]=rx_buffer[2];
	__GETB1MN _rx_buffer,2
	__PUTB1MN _B,1
;     273           R[2]=rx_buffer[3];
	__GETB1MN _rx_buffer,3
	__PUTB1MN _R,2
;     274           G[2]=rx_buffer[4];
	__GETB1MN _rx_buffer,4
	__PUTB1MN _G,2
;     275           B[2]=rx_buffer[5];
	__GETB1MN _rx_buffer,5
	__PUTB1MN _B,2
;     276           R[3]=rx_buffer[6];
	__GETB1MN _rx_buffer,6
	__PUTB1MN _R,3
;     277           G[3]=rx_buffer[7];
	__GETB1MN _rx_buffer,7
	__PUTB1MN _G,3
;     278           B[3]=rx_buffer[8];
	__GETB1MN _rx_buffer,8
	__PUTB1MN _B,3
;     279           R[4]=rx_buffer[9];
	__GETB1MN _rx_buffer,9
	__PUTB1MN _R,4
;     280           G[4]=rx_buffer[10];
	__GETB1MN _rx_buffer,10
	__PUTB1MN _G,4
;     281           B[4]=rx_buffer[11];
	__GETB1MN _rx_buffer,11
	__PUTB1MN _B,4
;     282       }
;     283     }
_0xC2:
;     284 
;     285     if (tx_index==50) tx_index=0;
_0xAD:
	LDI  R30,LOW(50)
	CP   R30,R4
	BRNE _0xC5
	CLR  R4
;     286     if (tx_index_tx==50) tx_index_tx=0;
_0xC5:
	LDI  R30,LOW(50)
	CP   R30,R7
	BRNE _0xC6
	CLR  R7
;     287 
;     288 //    if ((tx_index_tx!=tx_index)&&(!(UCSRA.5)))
;     289     if (tx_index_tx!=tx_index)
_0xC6:
	CP   R4,R7
	BREQ _0xC7
;     290     {//      
;     291 //        UDR = tx_buffer[tx_index_tx];
;     292         putchar(tx_buffer[tx_index_tx]);
	MOV  R30,R7
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	LD   R30,Z
	ST   -Y,R30
	RCALL _putchar
;     293         tx_index_tx++;
	INC  R7
;     294     }
;     295   }
_0xC7:
	RJMP _0x3D
;     296 }
_0xC8:
	RJMP _0xC8

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET

	.DSEG
_p_S44:
	.BYTE 0x2

	.CSEG

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
