/*****************************************************
Project : Ambilight   
Version : 1.2
Date    : 10.08.2009
Author  : StalkerSVR                      
Comments: 
 - 8
  - 14.7456
   USART  

Chip type           : ATmega8
Program type        : Application
Clock frequency     : 14,745600 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-




char R[5];
char G[5];
char B[5];
char E[5]; //Enable

char rx_buffer[30]; 
char tx_buffer[50];
char rx_index=0;  
char tx_index=0;
char tx_index_tx=0;
char start_channel;
char current_channel;
char num_channels;
char read_byte;
char need_rx=0;
char counter=0;
char packet_len=0;
char i;

void main(void)
{

PORTB=0x00;
DDRB=0x00;
PORTC=0x00;
DDRC=0x00;
PORTD=0x00;
DDRD=0x00;

DDRC.3=1;//R1 
DDRC.4=1;//G1
DDRC.5=1;//B1
DDRC.0=1;//R2
DDRC.1=1;//G2
DDRC.2=1;//B2
DDRB.2=1;//R3
DDRB.3=1;//G3
DDRB.4=1;//B3
DDRD.7=1;//R4
DDRB.0=1;//G4
DDRB.1=1;//B4

DDRD.0=0; //RXD
DDRD.1=1; //TXD

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 38400
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x17;
//UBRRL=0x0C;


  R[1]=0;
  G[1]=0;
  B[1]=0;
  E[1]=0;
  R[2]=0;
  G[2]=0;
  B[2]=0;
  E[2]=0;
  R[3]=0;
  G[3]=0;
  B[3]=0;
  E[3]=0;
  R[4]=0;
  G[4]=0;
  B[4]=0;
  E[4]=0;
  PORTC.3=0;
  PORTC.0=0;
  PORTB.2=0;
  PORTD.7=0;
  PORTC.4=0;
  PORTC.1=0;
  PORTB.3=0;
  PORTB.0=0;
  PORTC.5=0;
  PORTC.2=0;
  PORTB.4=0;
  PORTB.1=0;
  



// Global enable interrupts
  #asm("sei")

rx_index=0; 
need_rx=0;   
packet_len=0;

for (i=0;i<30;i++) rx_buffer[i]=0;
for (i=0;i<50;i++) tx_buffer[i]=0;

    
  while (1)
  {
    counter++;
    if(counter==0)
    {
        if(R[1]) PORTC.3=1; else PORTC.3=0;
        if(R[2]) PORTC.0=1; else PORTC.0=0;
        if(R[3]) PORTB.2=1; else PORTB.2=0;
        if(R[4]) PORTD.7=1; else PORTD.7=0;
        if(G[1]) PORTC.4=1; else PORTC.4=0;
        if(G[2]) PORTC.1=1; else PORTC.1=0;
        if(G[3]) PORTB.3=1; else PORTB.3=0;
        if(G[4]) PORTB.0=1; else PORTB.0=0;
        if(B[1]) PORTC.5=1; else PORTC.5=0;
        if(B[2]) PORTC.2=1; else PORTC.2=0;
        if(B[3]) PORTB.4=1; else PORTB.4=0;
        if(B[4]) PORTB.1=1; else PORTB.1=0;

    }

    if(counter>R[1])PORTC.3=0; if(counter>G[1])PORTC.4=0; if(counter>B[1])PORTC.5=0;
    if(counter>R[2])PORTC.0=0; if(counter>G[2])PORTC.1=0; if(counter>B[2])PORTC.2=0;
    if(counter>R[3])PORTB.2=0; if(counter>G[3])PORTB.3=0; if(counter>B[3])PORTB.4=0;
    if(counter>R[4])PORTD.7=0; if(counter>G[4])PORTB.0=0; if(counter>B[4])PORTB.1=0;
    
    if(UCSRA.7==1) 
    {
      read_byte=UDR;

      switch (rx_index) 
      {
        case 0: 
                if (read_byte==0xFF) //////////////////////////////
                {
                        need_rx=1; // 
                        tx_buffer[tx_index]=0xFF; ///////////////
                        tx_index++;
                        rx_index++;              
                };         
                break;
                
        case 1:                   
//                read_byte=0; ////////////////////////////////
                if (read_byte<12 )
                { //     
                        tx_buffer[tx_index]=0;                                
                }
                else
                {       //    
                         tx_buffer[tx_index]=read_byte - 12 ;
                }
                tx_index++;
                rx_index++;
                current_channel=read_byte;                
                start_channel=read_byte;
                break;
                
        case 2: // ignore,  256 , HIGH BYTE 
                tx_buffer[tx_index]=0; // 0  
                tx_index++;
                rx_index++;
                break;
                
        case 3: 
                if(!read_byte)
                {//  0 .         
                         tx_buffer[tx_index]=0; // 0  
                }
                else
                {// 
                         if(read_byte+start_channel<=12 )
                         {//    
                                   tx_buffer[tx_index]=0;
                         }                                        
                         else
                         {//   - 
                                   if (start_channel<12 )
                                   {//   .       
                                          tx_buffer[tx_index]=read_byte - 12   + start_channel;
                                   }
                                   else
                                   {//     
                                          tx_buffer[tx_index]=read_byte;
                                   }                      
                         }                              
                         num_channels=read_byte;
                }                               
                packet_len=4+read_byte; //     +  
                tx_index++;
                rx_index++;
                break;
                
        default:     
                if (need_rx)
                {
                        if (current_channel<12 )
                        {//   
                               rx_buffer[current_channel]=read_byte;
                        }                         
                        else                           
                        {//   ,   
                               tx_buffer[tx_index]=read_byte;
                               tx_index++;
                        }
                        current_channel++;   
                        rx_index++;
                }
                break;
                   
      }            
      
      if ((rx_index>=packet_len)&&(packet_len)) //     
      {
          rx_index=0; 
          need_rx=0;   
          packet_len=0;
          R[1]=rx_buffer[0];
          G[1]=rx_buffer[1];
          B[1]=rx_buffer[2];
          R[2]=rx_buffer[3];
          G[2]=rx_buffer[4];
          B[2]=rx_buffer[5];
          R[3]=rx_buffer[6];
          G[3]=rx_buffer[7];
          B[3]=rx_buffer[8];
          R[4]=rx_buffer[9];
          G[4]=rx_buffer[10];
          B[4]=rx_buffer[11];
      }
    }          
    
    if (tx_index==50) tx_index=0;
    if (tx_index_tx==50) tx_index_tx=0;

//    if ((tx_index_tx!=tx_index)&&(!(UCSRA.5)))    
    if (tx_index_tx!=tx_index)    
    {//      
//        UDR = tx_buffer[tx_index_tx];    
        putchar(tx_buffer[tx_index_tx]);
        tx_index_tx++;
    }
  }
}
